Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 321757 - kde-base/kdelibs-4.4.4 does not emerge on multi-core (parallel make issue?)
Summary: kde-base/kdelibs-4.4.4 does not emerge on multi-core (parallel make issue?)
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] KDE (show other bugs)
Hardware: AMD64 Linux
: High normal (vote)
Assignee: Gentoo KDE team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 313999
  Show dependency tree
 
Reported: 2010-05-28 03:46 UTC by mehrunes
Modified: 2011-04-05 23:08 UTC (History)
3 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge --info, 8-proc (emerge--info.8proc,4.80 KB, text/plain)
2010-05-28 03:47 UTC, mehrunes
Details
5 emerge log - 3 successes, 2 failures (log.8proc.3_plus_2.7z,140.95 KB, application/x-7zip-compressed)
2010-05-28 03:48 UTC, mehrunes
Details
emerge --info, 16-proc (emerge--info.16proc,4.50 KB, text/plain)
2010-05-28 03:48 UTC, mehrunes
Details
9 emerge log, 2 success, 7 failures (log.16proc.7z,136.06 KB, application/x-7zip-compressed)
2010-05-28 03:49 UTC, mehrunes
Details
emerge --info of the chroot, specially crafted for compiling kdelibs (chroot-emerge--info,4.15 KB, text/plain)
2010-06-08 07:29 UTC, mehrunes
Details
full output of emerge -uDpvN world, asked in post no. 9 (emerge-world.cout,139 bytes, text/plain)
2010-06-09 09:31 UTC, mehrunes
Details
emerge --info, taken after unsuccessful attempt to emerge kdelibs-4.4.4 (emerge--info,4.05 KB, text/plain)
2010-06-09 09:36 UTC, mehrunes
Details
failed emerge log (failed.emerge.log,223.80 KB, text/plain)
2010-06-09 09:41 UTC, mehrunes
Details
Failed emerge log, with cmake upgraded as suggested in post no. 17 (failed.log,101.94 KB, text/plain)
2010-06-17 15:49 UTC, mehrunes
Details
emerge --info of my chroot, with upgraded cmake (emerge--info,4.05 KB, text/plain)
2010-06-17 15:50 UTC, mehrunes
Details

Note You need to log in before you can comment on or make changes to this bug.
Description mehrunes 2010-05-28 03:46:06 UTC
+++ This bug was initially created as a clone of Bug #300953 +++

i failed to reopen bug no. 300953, so i clone it

the bug still exists in kde-base/kdelibs-4.3.5, it shows up not always

I did 5 experiments on 8-processor PC without ccache, and 9 experiments on 16-proc with ccache

It failed twice on 8-proc and 7 times on 16-proc

In all failures, error message is the same:

make[2]: *** No rule to make target `solid/solid/solid_automoc.cpp', needed by `solid/solid/solid_static_automoc.cpp'.  Stop.
Comment 1 mehrunes 2010-05-28 03:47:17 UTC
Created attachment 233197 [details]
emerge --info, 8-proc
Comment 2 mehrunes 2010-05-28 03:48:16 UTC
Created attachment 233199 [details]
5 emerge log - 3 successes, 2 failures
Comment 3 mehrunes 2010-05-28 03:48:56 UTC
Created attachment 233201 [details]
emerge --info, 16-proc
Comment 4 mehrunes 2010-05-28 03:49:44 UTC
Created attachment 233203 [details]
9 emerge log, 2 success, 7 failures
Comment 5 Andreas K. Hüttel archtester gentoo-dev 2010-06-06 17:46:01 UTC
Could you try 4.4.4 (current stable candidate) please?!
Comment 6 mehrunes 2010-06-07 04:11:06 UTC
(In reply to comment #5)
> Could you try 4.4.4 (current stable candidate) please?!
> 
yes, but this will require either installation and deletion of lots of packages, or making experiment in a new virtual machine or chroot. 

Since i don't want to break things, i will do this in freshly installed Gentoo on virtual machine. 

Don't expect this to happen very soon

Comment 7 mehrunes 2010-06-08 07:24:11 UTC
(In reply to comment #5)
> Could you try 4.4.4 (current stable candidate) please?!


No, i can't, and no one can, due to contradictory requirements of kdelibs-4.4.4 and its dependancy x11-libs/qt-opengl

kdelibs wants x11-libs/qt-core with qt3support ON

kdelibs also wants x11-libs/qt-opengl

and x11-libs/qt-opengl wants x11-libs/qt-core with qt3support OFF


relevant emerge messages go below in this post, and emerge --info output later 


echo x11-libs/qt-core qt3support >> /etc/portage/package.use
emerge -p kdelibs

emerge: there are no ebuilds built with USE flags to satisfy "~x11-libs/qt-core-4.6.2[-debug,-qt3support,-aqua]".
!!! One of the following packages is required to complete your request:
- x11-libs/qt-core-4.6.2-r1 (Change USE: -qt3support)
(dependency required by "x11-libs/qt-opengl-4.6.2" [ebuild])
(dependency required by "kde-base/kdelibs-4.4.4" [ebuild])
(dependency required by "kdelibs" [argument])

sed "-ie:qt-core qt3support:qt-core -qt3support" /etc/portage/package.use
emerge -p kdelibs
 
emerge: there are no ebuilds built with USE flags to satisfy ">=x11-libs/qt-core-4.6.0:4[qt3support,ssl]".
!!! One of the following packages is required to complete your request:
- x11-libs/qt-core-4.6.2-r1 (Change USE: +qt3support)
(dependency required by "kde-base/kdelibs-4.4.4" [ebuild])
(dependency required by "kdelibs" [argument])
Comment 8 mehrunes 2010-06-08 07:29:41 UTC
Created attachment 234503 [details]
emerge --info of the chroot, specially crafted for compiling kdelibs

I made a chroot of portage tree dated 07 june, stage3 ball called stage3-amd64-20100514.tar.bz2, and my portage setup

Then started tweaking portage setup, to please kdelibs-4.4.4...
Comment 9 Jorge Manuel B. S. Vicetto Gentoo Infrastructure gentoo-dev 2010-06-08 12:21:26 UTC
To avoid circular dep issues with qt packages, it's better to define the "qt3support" use flag in /etc/make.conf.

Please add the full output of emerge -uDpvN world (@world if you have portage-2.2) and rest assured that it's possible to update to KDE-4.4.4.
Comment 10 mehrunes 2010-06-08 16:23:14 UTC
(In reply to comment #9)
> To avoid circular dep issues with qt packages, it's better to define the
> "qt3support" use flag in /etc/make.conf.
> 
> Please add the full output of emerge -uDpvN world (@world if you have
> portage-2.2) and rest assured that it's possible to update to KDE-4.4.4.
> 
will do both things tomorrow when i get to my 16-proc

to increase probability of successful emerge and shorten this thread, will you please kindly tell me today: is there anything else i can do to please kdelibs-4.4.4 besides turning on qt3support globally?
Comment 11 Jorge Manuel B. S. Vicetto Gentoo Infrastructure gentoo-dev 2010-06-08 16:34:47 UTC
The following are the use flags used by the qt packages on my desktop with kde-4.4.4:

$ grep -H "" /var/db/pkg/x11-libs/qt*/USE
/var/db/pkg/x11-libs/qt-core-4.6.2-r1/USE:amd64 elibc_glibc exceptions glib iconv kernel_linux multilib qt3support ssl userland_GNU
/var/db/pkg/x11-libs/qt-dbus-4.6.2/USE:amd64 elibc_glibc exceptions kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-gui-4.6.2-r1/USE:accessibility amd64 cups dbus elibc_glibc exceptions glib kernel_linux mng multilib qt3support userland_GNU
/var/db/pkg/x11-libs/qt-opengl-4.6.2/USE:amd64 elibc_glibc exceptions kernel_linux multilib qt3support userland_GNU
/var/db/pkg/x11-libs/qt-qt3support-4.6.2/USE:accessibility amd64 elibc_glibc exceptions kde kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-script-4.6.2/USE:amd64 elibc_glibc exceptions iconv kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qtscriptgenerator-0.1.0/USE:amd64 elibc_glibc kde kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-sql-4.6.2/USE:amd64 elibc_glibc exceptions iconv kernel_linux multilib mysql qt3support sqlite userland_GNU
/var/db/pkg/x11-libs/qt-svg-4.6.2/USE:amd64 elibc_glibc exceptions iconv kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-test-4.6.2/USE:amd64 elibc_glibc exceptions iconv kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-webkit-4.6.2-r1/USE:amd64 dbus elibc_glibc exceptions kde kernel_linux multilib userland_GNU
/var/db/pkg/x11-libs/qt-xmlpatterns-4.6.2/USE:amd64 elibc_glibc kernel_linux multilib userland_GNU
Comment 12 mehrunes 2010-06-09 09:31:26 UTC
Created attachment 234671 [details]
full output of emerge -uDpvN world, asked in post no. 9

aint nothing interesting in here
Comment 13 mehrunes 2010-06-09 09:36:15 UTC
Created attachment 234673 [details]
emerge --info, taken after unsuccessful attempt to emerge kdelibs-4.4.4

 Jorge Manuel, thank you for quick reply

kdelibs-4.4.4 did not compile, same error message as in 1st post "No rule to make target..."
Comment 14 mehrunes 2010-06-09 09:41:26 UTC
Created attachment 234675 [details]
failed emerge log

1st attempt of emerge failed. I did not retry, hence don't know the probability of success

If someone is interested in the probability, i can make multiple experiments
Comment 15 mehrunes 2010-06-09 09:44:00 UTC
i suggest changing bug header: prepending >=
Comment 16 Jorge Manuel B. S. Vicetto Gentoo Infrastructure gentoo-dev 2010-06-09 11:01:59 UTC
The build is failing with:

make[2]: *** No rule to make target `solid/solid/solid_automoc.cpp', needed by `solid/solid/solid_static_automoc.cpp'.  Stop.
Comment 17 Andreas K. Hüttel archtester gentoo-dev 2010-06-13 15:27:48 UTC
Could you maybe update cmake to cmake-2.8.1-r2 (current ~arch) and try again?
Should be pretty unproblematic, I never noticed any breakage.

I never had these problems, and also run with "-j9"...
Comment 18 mehrunes 2010-06-17 15:49:10 UTC
Created attachment 235731 [details]
Failed emerge log, with cmake upgraded as suggested in post no. 17

Upgrading cmake to 2.8.1-r2 does not solve the problem
Comment 19 mehrunes 2010-06-17 15:50:36 UTC
Created attachment 235733 [details]
emerge --info of my chroot, with upgraded cmake
Comment 20 Stuart Longland (RETIRED) gentoo-dev 2010-08-04 06:20:02 UTC
I can confirm this bug... and it seems to be all of KDE, not just kdelibs.  I've been battling this on a 6-core AMD PhenomII, which has MAKEOPTS="-j --load-average 5.0"

No logs that I can offer at this stage, I'll try another build when I've got some time to sit there and tinker.  It does look as if there's already plenty of logs above contributed by others.

The workaround for me was:
# MAKEOPTS="-j1" emerge -j --load-average 10.0 ... kde-meta

That at least allowed me to build KDE 4.4.4, and still make use of most of the 6 cores to speed the process up.  For those with multi-core or SMP systems, this may be a reasonable comprimise.
Comment 21 Andreas K. Hüttel archtester gentoo-dev 2011-02-12 22:46:23 UTC
Any similar issues with kde-4.5 or kde-4.6 ?
Comment 22 mehrunes 2011-03-14 08:11:02 UTC
(In reply to comment #21)

Though kdelibs is not my piece of cake (none of my computers is running kde), I will try to answer this question.

Currently I encounter difficulties: some kdelibs' dependancies do not emerge. I will hopefully post new bugreports soon
Comment 23 mehrunes 2011-03-16 05:16:21 UTC
Emerged kdelibs-4.6.1-r1 in chroot made of stage3-amd64-20110217.tar.bz2 (more than 100 packages emerged). Used 12-core Intel-R-_Core-TM-_i7_CPU_X_980_@_3.33GHz with MAKEOPTS set to '--jobs --load-average=36"

Emerged kdelibs 11 times. No failures after dependancies installed

Had problems with 5 packages (test failed on automake, dbus, glib, libarchive, libcdio), and no parallel-make problems

I leave bug status unchanged
Comment 24 Andreas K. Hüttel archtester gentoo-dev 2011-04-05 23:08:15 UTC
OK thanks for your efforts. Let's hope this is fixed in >=4.6.1 then. 4.4 will go away soon.